/**
 *  SimpleModbusRtu_example
 *  http://www.comfile.co.kr
 */

#include <SimpleModbusRtu_mega2560.h>


uint16_t au16data[16];
uint8_t au8data[10];
char n;
int incomingByte = 0; 

void setup() {
  char i;
  for(i=22; i<38; i++){ pinMode(i, INPUT); } // 22 ~ 37번의 입력
  for(i=38; i<52; i++){ pinMode(i, OUTPUT); }   // 38 ~ 51번의 출력 설정

  Serial.begin(9600);
  Serial3.begin(57600);

  usart1init(57600); // 9600, 19200, 38400, 57600 , Serial channel1
  startSimpleModbus(1,au16data, au8data); // slave address, register, coil
  
}

void loop() {
  
  for(n=0; n<8; n++){ bitWrite( au8data[0],n, digitalRead(n+22) ) ;}  //입력 
  for(n=0; n<8; n++){ bitWrite( au8data[1],n, digitalRead(n+30) ) ;}
  
  for(n=0; n<8; n++){ digitalWrite(38+n, bitRead(au8data[2], n) ) ;}  //출력
  for(n=0; n<8; n++){ digitalWrite(46+n, bitRead(au8data[3], n) ) ;}

}




